﻿using System.Collections;
using System.Collections.Generic;
using UnityEngine;
using System;

public class bluestuffsound : MonoBehaviour {
    int objno = 1;
    rtcmixmain RTcmix;
    private bool did_start = false;

    public TextAsset ibsscript, bsscript;
    String ibsscore, bsscore;

    rvbscript senddata; // this will locate the "rvb" object + data-sending function

    private getMyTransform localsrc; // to get position relative to 'observer'

    private void Awake()
    {
        RTcmix = GameObject.Find("RTcmixmain").GetComponent<rtcmixmain>();  // find RTcmix
        senddata = GameObject.Find("rvb").GetComponent<rvbscript>();  // find the rvb
        localsrc = GameObject.FindWithTag("thecam").GetComponent<getMyTransform>();  // find the camera (for LOCALIZE)
    }


    // Use this for initialization
    void Start()
    {
        RTcmix.initRTcmix(objno);

        ibsscore = ibsscript.text; // initialization txt file loading
        bsscore = bsscript.text; // run (in the RTcmix.checkbangRTcmix() function)

        RTcmix.SendScore(ibsscore, objno);

        did_start = true; // set this to signal OnAudioFilterRead() that RTcmix is ready for processing
    }

    // Update is called once per frame
    void Update()
    {
        if (!did_start) return; // not sure this is necessary here

        Vector3 srcpos = localsrc.getTransform(gameObject); // this source relative to the 'observer' object
        // note swap of y and z axes                                                  
        RTcmix.setpfieldRTcmix(1, srcpos.x, objno);
        RTcmix.setpfieldRTcmix(2, srcpos.z, objno);
    }

    void OnAudioFilterRead(float[] data, int nchannels)
    {
        if (!did_start) return;

        RTcmix.runRTcmix(data, objno, 0);

        senddata.SetInputData(ref data); // after running the RTcmix process, send the data to the rvb

        if (RTcmix.checkbangRTcmix(objno) == 1)
        {
            RTcmix.SendScore(bsscore, objno);
        }
    }

    void OnApplicationQuit()
    {
        did_start = false;
        RTcmix = null; // do this instead of the old RTcmix.destroy()
    }
}
