﻿using System.Collections;
using System.Collections.Generic;
using UnityEngine;

public class cubesoundscript : MonoBehaviour {
    int objno = 0;
    rtcmixmain RTcmix;
    private bool did_start = false;  // the flag to signal RTcmix is initialized

    rvbscript senddata; // this will locate the "rvb" object + data-sending function

    private getMyTransform localsrc; // to get position relative to 'observer'

    private void Awake()
    {
        RTcmix = GameObject.Find("RTcmixmain").GetComponent<rtcmixmain>();  // find RTcmix
        senddata = GameObject.Find("rvb").GetComponent<rvbscript>();  // find the rvb
        localsrc = GameObject.FindWithTag("thecam").GetComponent<getMyTransform>();  // find the camera (for LOCALIZE)
    }

    // Use this for initialization
    void Start () {
        RTcmix.initRTcmix(objno);

        // send the score 'by hand' here, not using txt files
        RTcmix.SendScore("reset(44100) " +
            "ampenv = maketable(\"line\", 1000, 0, 0, 1, 1, 9, 1, 10, 0) " +
            "bus_config(\"WAVETABLE\", \"aux 0-1 out\") " +
            "bus_config(\"LOCALIZE\", \"aux 0-1 in\", \"out 0-1\") " +
            "srcXa = makeconnection(\"inlet\", 1, 10) " +
            "srcYa = makeconnection(\"inlet\", 2, 10) " +
            "LOCALIZE(0, 0, 9999, 1, srcXa,srcYa,0, 0,0,0, 1.0, 1.0, 0, 1, 2, 0.01, 100) " +
            "MAXBANG(0.5)", objno);
                         
        did_start = true; // hey hey, we're ready-to-go in OnAudioFilterRead()
    }
	
	// Update is called once per frame
	void Update () {
        if (!did_start) return; // not sure this is necessary here

        Vector3 srcpos = localsrc.getTransform(gameObject); // this source relative to the 'observer' object
        // note swap of y and z axes                                                  
        RTcmix.setpfieldRTcmix(1, srcpos.x, objno);
        RTcmix.setpfieldRTcmix(2, srcpos.z, objno);
    }

    void OnAudioFilterRead(float[] data, int nchannels)
    {
        if (!did_start) return;

        RTcmix.runRTcmix(data, objno, 0);

        senddata.SetInputData(ref data); // send the data to rvb after processing it with RTcmix.runRTcmix()

        if (RTcmix.checkbangRTcmix(objno) == 1)
        {
            RTcmix.SendScore("WAVETABLE(0, 0.1, 20000*ampenv, 8.00, 0.5)  MAXBANG(0.5)", objno);
        }
    }

    void OnApplicationQuit()
    {
        did_start = false;
        RTcmix = null;  // do this instead of the old RTcmix.destroy() function
    }
}
