﻿using System.Collections;
using System.Collections.Generic;
using UnityEngine;
using System;

public class rvbscript : MonoBehaviour
{
    int objno = 2;
    rtcmixmain RTcmix;
    private bool did_start = false;

    float[] tdata = new float[2048];

    private void Awake()
    {
        RTcmix = GameObject.Find("RTcmixmain").GetComponent<rtcmixmain>();
    }

    // Use this for initialization
    void Start()
    {
        RTcmix.initRTcmix(objno);

        RTcmix.SendScore("rtinput(\"AUDIO\")  GVERB(0, 0, 9999, 0.9, 78.0, 7.0, 0.71, 0.34, -10.0, -11.0, -9.0, 7.0)", objno);

        Array.Clear(tdata, 0, tdata.Length);  // start with a clear array for getting samples from other RTcmixes

        did_start = true;
    }

    // Update is called once per frame
    void Update()
    {

    }

    public void SetInputData(ref float[] inarray)
    {
        // this is where we get incoming samples from other RTcmix objects.  Add them to the array
        // we will use for processing
        for (int i = 0; i < inarray.Length; i++)
        {
            tdata[i] += inarray[i];
        }
    }

    void OnAudioFilterRead(float[] data, int nchannels)
    {
        if (!did_start) return;

        for (int i = 0; i < data.Length; i++)
        {
            data[i] = tdata[i];
        }

        // now that ths samples have been processed, clear the array for the next go-round
        Array.Clear(tdata, 0, tdata.Length);

        RTcmix.runRTcmix(data, objno, 1);
    }

    void OnApplicationQuit()
    {
        did_start = false;
        RTcmix = null;
    }
}